Index: src/Actions/SelectionAction/AllAtomsAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllAtomsAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllAtomsAction.hpp"
 
+// and construct the stuff
+#include "AllAtomsAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionAllAtomsAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionAllAtomsState : public ActionState {
-public:
-  SelectionAllAtomsState(std::vector<atom*> _selectedAtoms) :
-    selectedAtoms(_selectedAtoms)
-  {}
-  std::vector<atom*> selectedAtoms;
-};
-
-const char SelectionAllAtomsAction::NAME[] = "select-all-atoms";
-
-SelectionAllAtomsAction::SelectionAllAtomsAction() :
-  Action(NAME)
-{}
-
-SelectionAllAtomsAction::~SelectionAllAtomsAction()
-{}
-
-void SelectionAllAtoms() {
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllAtomsAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAllAtomsAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionAllAtomsAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
   DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms." << endl);
   World::getInstance().selectAllAtoms(AllAtoms());
-  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms));
+  return Action::state_ptr(new SelectionAllAtomsState(selectedAtoms,params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionAllAtomsAction::performRedo(Action::state_ptr _state){
-  SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
+  //SelectionAllAtomsState *state = assert_cast<SelectionAllAtomsState*>(_state.get());
 
   World::getInstance().selectAllAtoms(AllAtoms());
 
-  return Action::state_ptr(new SelectionAllAtomsState(state->selectedAtoms));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AllAtomsAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AllAtomsAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllAtoms
+#define TOKEN "select-all-atoms"
+
Index: src/Actions/SelectionAction/AllAtomsAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionAllAtoms();
-
-class SelectionAllAtomsAction : public Action {
-  friend void SelectionAllAtoms();
-
-public:
-  SelectionAllAtomsAction();
-  virtual ~SelectionAllAtomsAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllAtomsAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLATOMSACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "Descriptors/AtomShapeDescriptor.hpp"
@@ -39,89 +37,23 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionAllAtomsInsideCuboidState : public ActionState {
-public:
-  SelectionAllAtomsInsideCuboidState(std::vector<atom*> _selectedAtoms, const Vector &_position, const Vector &_extension, const double _Xangle, const double _Yangle, const double _Zangle) :
-    selectedAtoms(_selectedAtoms),
-    position(_position),
-    extension(_extension),
-    Xangle(_Xangle),
-    Yangle(_Yangle),
-    Zangle(_Zangle)
-  {}
-  std::vector<atom*> selectedAtoms;
-  Vector position;
-  Vector extension;
-  double Xangle;
-  double Yangle;
-  double Zangle;
-};
-
-const char SelectionAllAtomsInsideCuboidAction::NAME[] = "select-atoms-inside-cuboid";
-
-SelectionAllAtomsInsideCuboidAction::SelectionAllAtomsInsideCuboidAction() :
-  Action(NAME)
-{}
-
-SelectionAllAtomsInsideCuboidAction::~SelectionAllAtomsInsideCuboidAction()
-{}
-
-void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension) {
-  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideCuboidAction::NAME, extension);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle) {
-  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideCuboidAction::NAME, extension);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ValueStorage::getInstance().setCurrentValue("angle-x", Xangle);
-  ValueStorage::getInstance().setCurrentValue("angle-y", Yangle);
-  ValueStorage::getInstance().setCurrentValue("angle-z", Zangle);
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideCuboidAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllAtomsInsideCuboidAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAllAtomsInsideCuboidAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryVector(NAME, false, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AllAtomsInsideCuboidAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionAllAtomsInsideCuboidAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
-  Vector position;
-  Vector extension;
-  double Xangle = 0.;
-  double Yangle = 0.;
-  double Zangle = 0.;
   Matrix RotationMatrix;
 
-  ValueStorage::getInstance().queryCurrentValue("position", position);
-  ValueStorage::getInstance().queryCurrentValue(NAME, extension);
-  // check whether a rotation is given.
-  if (ValueStorage::getInstance().queryCurrentValue("angle-x", Xangle, true))
-    Xangle = 0.;
-  if (ValueStorage::getInstance().queryCurrentValue("angle-y", Yangle, true))
-    Yangle = 0.;
-  if (ValueStorage::getInstance().queryCurrentValue("angle-z", Zangle, true))
-    Zangle = 0.;
-  RotationMatrix.rotation(Xangle, Yangle, Zangle);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << position << " and extension of " << extension << "." << endl);
-  Shape s = translate(transform(stretch(Cuboid(),extension),RotationMatrix),position);
+  RotationMatrix.rotation(params.Xangle, params.Yangle, params.Zangle);
+
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a rotated " << RotationMatrix << " cuboid at " << params.position << " and extension of " << params.extension << "." << endl);
+  Shape s = translate(transform(stretch(Cuboid(),params.extension),RotationMatrix),params.position);
   World::getInstance().selectAllAtoms(AtomByShape(s));
-  return Action::state_ptr(new SelectionAllAtomsInsideCuboidState(selectedAtoms, position, extension, Xangle, Yangle, Zangle));
+  return Action::state_ptr(new SelectionAllAtomsInsideCuboidState(selectedAtoms, params));
 }
 
@@ -140,6 +72,6 @@
   Matrix RotationMatrix;
 
-  RotationMatrix.rotation(state->Xangle, state->Yangle, state->Zangle);
-  Shape s = translate(transform(stretch(Cuboid(),state->extension),RotationMatrix),state->position);
+  RotationMatrix.rotation(state->params.Xangle, state->params.Yangle, state->params.Zangle);
+  Shape s = translate(transform(stretch(Cuboid(),state->params.extension),RotationMatrix),state->params.position);
   World::getInstance().selectAllAtoms(AtomByShape(s));
 
@@ -158,2 +90,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AllAtomsInsideCuboidAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class Vector;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (Vector) (Vector) (double) (double) (double)
+#define paramtokens (SelectionAllAtomsInsideCuboidAction::NAME) ("position") ("angle-x") ("angle-y") ("angle-z")
+#define paramreferences (extension) (position) (Xangle) (Yangle) (Zangle)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllAtomsInsideCuboid
+#define TOKEN "select-atoms-inside-cuboid"
+
Index: src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsInsideCuboidAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,30 +11,6 @@
 #include "Actions/Action.hpp"
 
-class Vector;
-
-void SelectionAllAtomsInsideCuboid();
-
-class SelectionAllAtomsInsideCuboidAction : public Action {
-  friend void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension);
-  friend void SelectionAllAtomsInsideCuboid(const Vector &position, const Vector &extension, const double Xangle, const double Yangle, const double Zangle);
-
-public:
-  SelectionAllAtomsInsideCuboidAction();
-  virtual ~SelectionAllAtomsInsideCuboidAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllAtomsInsideCuboidAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLATOMSINSIDECUBOIDACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllAtomsInsideSphereAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "Descriptors/AtomShapeDescriptor.hpp"
@@ -38,62 +36,20 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllAtomsInsideSphereAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionAllAtomsInsideSphereState : public ActionState {
-public:
-  SelectionAllAtomsInsideSphereState(std::vector<atom*> _selectedAtoms, const Vector &_position, const double _radius) :
-    selectedAtoms(_selectedAtoms),
-    position(_position),
-    radius(_radius)
-  {}
-  std::vector<atom*> selectedAtoms;
-  Vector position;
-  double radius;
-};
-
-const char SelectionAllAtomsInsideSphereAction::NAME[] = "select-atoms-inside-sphere";
-
-SelectionAllAtomsInsideSphereAction::SelectionAllAtomsInsideSphereAction() :
-  Action(NAME)
-{}
-
-SelectionAllAtomsInsideSphereAction::~SelectionAllAtomsInsideSphereAction()
-{}
-
-void SelectionAllAtomsInsideSphere(const Vector &position, const double radius) {
-  ValueStorage::getInstance().setCurrentValue(SelectionAllAtomsInsideSphereAction::NAME, radius);
-  ValueStorage::getInstance().setCurrentValue("position", position);
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsInsideSphereAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllAtomsInsideSphereAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAllAtomsInsideSphereAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryDouble(NAME, ValueStorage::getInstance().getDescription(NAME));
-  dialog->queryVector("position", false, ValueStorage::getInstance().getDescription("position"));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AllAtomsInsideSphereAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionAllAtomsInsideSphereAction::performCall() {
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
-  double radius = 0.;
-  Vector position;
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, radius);
-  ValueStorage::getInstance().queryCurrentValue("position", position);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a sphere at " << position << " with radius " << radius << "." << endl);
-  Shape s = translate(resize(Sphere(),radius),position);
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms inside a sphere at " << params.position << " with radius " << params.radius << "." << endl);
+  Shape s = translate(resize(Sphere(),params.radius),params.position);
   World::getInstance().selectAllAtoms(AtomByShape(s));
-  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(selectedAtoms, position, radius));
+  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(selectedAtoms, params));
 }
 
@@ -105,5 +61,5 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+  return Action::state_ptr(_state);
 }
 
@@ -111,8 +67,8 @@
   SelectionAllAtomsInsideSphereState *state = assert_cast<SelectionAllAtomsInsideSphereState*>(_state.get());
 
-  Shape s = translate(resize(Sphere(),state->radius),state->position);
+  Shape s = translate(resize(Sphere(),state->params.radius),state->params.position);
   World::getInstance().selectAllAtoms(AtomByShape(s));
 
-  return Action::state_ptr(new SelectionAllAtomsInsideSphereState(state->selectedAtoms, state->position, state->radius));
+  return Action::state_ptr(_state);
 }
 
@@ -128,2 +84,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AllAtomsInsideSphereAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class Vector;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (double) (Vector)
+#define paramtokens (SelectionAllAtomsInsideSphereAction::NAME) ("position")
+#define paramreferences (radius) (position)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllAtomsInsideSphere
+#define TOKEN "select-atoms-inside-sphere"
+
Index: src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsInsideSphereAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,29 +11,6 @@
 #include "Actions/Action.hpp"
 
-class Vector;
-
-void SelectionAllAtomsInsideSphere();
-
-class SelectionAllAtomsInsideSphereAction : public Action {
-  friend void SelectionAllAtomsInsideSphere(const Vector &position, const double radius);
-
-public:
-  SelectionAllAtomsInsideSphereAction();
-  virtual ~SelectionAllAtomsInsideSphereAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllAtomsInsideSphereAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLATOMSINSIDESPHEREACTION_HPP_ */
Index: src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsOfMoleculeAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/AtomDescriptor.hpp"
 #include "atom.hpp"
@@ -34,54 +32,19 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp"
 
-
-// memento to remember the state when undoing
-
-class SelectionAllAtomsOfMoleculeState : public ActionState {
-public:
-  SelectionAllAtomsOfMoleculeState(std::vector<atom*> _selectedAtoms, molecule *_mol) :
-    selectedAtoms(_selectedAtoms),
-    mol(_mol)
-  {}
-  std::vector<atom*> selectedAtoms;
-  molecule *mol;
-};
-
-const char SelectionAllAtomsOfMoleculeAction::NAME[] = "select-molecules-atoms";
-
-SelectionAllAtomsOfMoleculeAction::SelectionAllAtomsOfMoleculeAction() :
-  Action(NAME)
-{}
-
-SelectionAllAtomsOfMoleculeAction::~SelectionAllAtomsOfMoleculeAction()
-{}
-
-void SelectionAllAtomsOfMolecule() {
-  ActionRegistry::getInstance().getActionByName(SelectionAllAtomsOfMoleculeAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllAtomsOfMoleculeAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAllAtomsOfMoleculeAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryMolecule(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
+// and construct the stuff
+#include "AllAtomsOfMoleculeAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
 Action::state_ptr SelectionAllAtomsOfMoleculeAction::performCall() {
-  molecule *mol = NULL;
   std::vector<atom *> selectedAtoms = World::getInstance().getSelectedAtoms();
 
-  ValueStorage::getInstance().queryCurrentValue(NAME, mol);
+  // obtain information
+  getParametersfromValueStorage();
 
-  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms of molecule " << mol->getName() << "." << endl);
-  World::getInstance().selectAtomsOfMolecule(mol);
-  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(selectedAtoms, mol));
+  DoLog(1) && (Log() << Verbose(1) << "Selecting all atoms of molecule " << params.mol->getName() << "." << endl);
+  World::getInstance().selectAtomsOfMolecule(params.mol);
+  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(selectedAtoms, params));
 }
 
@@ -93,5 +56,5 @@
     World::getInstance().selectAtom(*iter);
 
-  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -99,7 +62,7 @@
   SelectionAllAtomsOfMoleculeState *state = assert_cast<SelectionAllAtomsOfMoleculeState*>(_state.get());
 
-  World::getInstance().selectAtomsOfMolecule(state->mol);
+  World::getInstance().selectAtomsOfMolecule(state->params.mol);
 
-  return Action::state_ptr(new SelectionAllAtomsOfMoleculeState(state->selectedAtoms, state->mol));
+  return Action::state_ptr(_state);
 }
 
@@ -115,2 +78,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllAtomsOfMoleculeAction.def
===================================================================
--- src/Actions/SelectionAction/AllAtomsOfMoleculeAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AllAtomsOfMoleculeAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,25 @@
+/*
+ * AllAtomsOfMoleculeAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+class molecule;
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#define paramtypes (molecule *)
+#define paramtokens (SelectionAllAtomsOfMoleculeAction::NAME)
+#define paramreferences (mol)
+
+#define statetypes (std::vector<atom*>)
+#define statereferences (selectedAtoms)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllAtomsOfMolecule
+#define TOKEN "select-molecules-atoms"
+
Index: src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp
===================================================================
--- src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllAtomsOfMoleculeAction.hpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -11,27 +11,6 @@
 #include "Actions/Action.hpp"
 
-void SelectionAllAtomsOfMolecule();
-
-class SelectionAllAtomsOfMoleculeAction : public Action {
-  friend void SelectionAllAtomsOfMolecule();
-
-public:
-  SelectionAllAtomsOfMoleculeAction();
-  virtual ~SelectionAllAtomsOfMoleculeAction();
-
-  bool canUndo();
-  bool shouldUndo();
-
-  virtual const std::string getName();
-protected:
-  virtual Dialog * fillDialog(Dialog *dialog);
-private:
-  virtual void getParametersfromValueStorage();
-  virtual Action::state_ptr performCall();
-  virtual Action::state_ptr performUndo(Action::state_ptr);
-  virtual Action::state_ptr performRedo(Action::state_ptr);
-
-  static const char NAME[];
-};
+#include "AllAtomsOfMoleculeAction.def"
+#include "Action_impl_header.hpp"
 
 #endif /* ALLATOMSOFMOLECULEACTION_HPP_ */
Index: src/Actions/SelectionAction/AllMoleculesAction.cpp
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision 0b2ce98def2d6ab9548ba5ac25acbb2ab5bc233c)
+++ src/Actions/SelectionAction/AllMoleculesAction.cpp	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -20,6 +20,4 @@
 #include "Helpers/MemDebug.hpp"
 
-#include "Actions/SelectionAction/AllMoleculesAction.hpp"
-#include "Actions/ActionRegistry.hpp"
 #include "Descriptors/MoleculeDescriptor.hpp"
 #include "atom.hpp"
@@ -33,48 +31,18 @@
 using namespace std;
 
-#include "UIElements/UIFactory.hpp"
-#include "UIElements/Dialog.hpp"
-#include "Actions/ValueStorage.hpp"
+#include "Actions/SelectionAction/AllMoleculesAction.hpp"
 
+// and construct the stuff
+#include "AllMoleculesAction.def"
+#include "Action_impl_pre.hpp"
+/** =========== define the function ====================== */
+Action::state_ptr SelectionAllMoleculesAction::performCall() {
+  // obtain information
+  getParametersfromValueStorage();
 
-// memento to remember the state when undoing
-
-class SelectionAllMoleculesState : public ActionState {
-public:
-  SelectionAllMoleculesState(std::vector<molecule*> selectedMolecules) :
-    selectedMolecules(selectedMolecules)
-  {}
-  std::vector<molecule*> selectedMolecules;
-};
-
-const char SelectionAllMoleculesAction::NAME[] = "select-all-molecules";
-
-SelectionAllMoleculesAction::SelectionAllMoleculesAction() :
-  Action(NAME)
-{}
-
-SelectionAllMoleculesAction::~SelectionAllMoleculesAction()
-{}
-
-void SelectionAllMolecules() {
-  ActionRegistry::getInstance().getActionByName(SelectionAllMoleculesAction::NAME)->call(Action::NonInteractive);
-};
-
-void SelectionAllMoleculesAction::getParametersfromValueStorage()
-{};
-
-Dialog* SelectionAllMoleculesAction::fillDialog(Dialog *dialog) {
-  ASSERT(dialog,"No Dialog given when filling action dialog");
-
-  dialog->queryEmpty(NAME, ValueStorage::getInstance().getDescription(NAME));
-
-  return dialog;
-}
-
-Action::state_ptr SelectionAllMoleculesAction::performCall() {
   std::vector<molecule *> selectedMolecules = World::getInstance().getSelectedMolecules();
   DoLog(1) && (Log() << Verbose(1) << "Selecting all molecules." << endl);
   World::getInstance().selectAllMolecules(AllMolecules());
-  return Action::state_ptr(new SelectionAllMoleculesState(selectedMolecules));
+  return Action::state_ptr(new SelectionAllMoleculesState(selectedMolecules,params));
 }
 
@@ -86,13 +54,13 @@
     World::getInstance().selectMolecule(*iter);
 
-  return Action::state_ptr(new SelectionAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
 Action::state_ptr SelectionAllMoleculesAction::performRedo(Action::state_ptr _state){
-  SelectionAllMoleculesState *state = assert_cast<SelectionAllMoleculesState*>(_state.get());
+  //SelectionAllMoleculesState *state = assert_cast<SelectionAllMoleculesState*>(_state.get());
 
   World::getInstance().selectAllMolecules(AllMolecules());
 
-  return Action::state_ptr(new SelectionAllMoleculesState(state->selectedMolecules));
+  return Action::state_ptr(_state);
 }
 
@@ -108,2 +76,3 @@
   return NAME;
 }
+/** =========== end of function ====================== */
Index: src/Actions/SelectionAction/AllMoleculesAction.def
===================================================================
--- src/Actions/SelectionAction/AllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
+++ src/Actions/SelectionAction/AllMoleculesAction.def	(revision 966e12d8a822176e4558e3229d5f45d6231cc1c0)
@@ -0,0 +1,24 @@
+/*
+ * AllMoleculesAction.def
+ *
+ *  Created on: Aug 26, 2010
+ *      Author: heber
+ */
+
+// all includes and forward declarations necessary for non-integral types below
+
+// i.e. there is an integer with variable name Z that can be found in
+// ValueStorage by the token "Z" -> first column: int, Z, "Z"
+// "undefine" if no parameters are required
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+
+#define statetypes (std::vector<molecule*>)
+#define statereferences (selectedMolecules)
+
+// some defines for all the names, you may use ACTION, STATE and PARAMS
+#define CATEGORY Selection
+#define ACTIONNAME AllMolecules
+#define TOKEN "select-all-molecules"
+
